package com.iohao.mmo.equip.action;

import com.iohao.game.action.skeleton.annotation.ActionController;
import com.iohao.game.action.skeleton.annotation.ActionMethod;
import com.iohao.game.action.skeleton.core.flow.FlowContext;
import com.iohao.game.action.skeleton.protocol.wrapper.LongValue;
import com.iohao.mmo.equip.cmd.EquipCmd;
import com.iohao.mmo.equip.entity.Equip;
import com.iohao.mmo.equip.mapper.EquipMapper;
import com.iohao.mmo.equip.proto.EquipMessage;
import com.iohao.mmo.equip.proto.OfEquipReq;
import com.iohao.mmo.equip.service.EquipService;
import jakarta.annotation.Resource;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

/**
 * @author 唐斌
 * @date 2023-07-30
 * @description: 装备属性类
 */
@Slf4j
@Component
@ActionController(EquipCmd.cmd)
public class EquipAction {

    @Resource
    EquipService equipService;

    /**
     * 初始化装备信息
     *
     * @param flowContext flowContext
     */
    @ActionMethod(EquipCmd.initEquip)
    public void internalInitEquip(FlowContext flowContext) {
        long userId = flowContext.getUserId();
        // 初始化装备数据，暂时放这
        equipService.initEquipData();
    }

    /**
     * 获取装备信息
     *
     * @param flowContext flowContext
     */
    @ActionMethod(EquipCmd.getEquip)
//    public EquipMessage getEquip(FlowContext flowContext, OfEquipReq ofEquipReq) { //对象
    public EquipMessage getEquip(FlowContext flowContext, LongValue longValue) { //参数值
        // 初始化装备数据，暂时放这
        Equip equip = equipService.ofEquip(longValue.value);
        return EquipMapper.ME.convert(equip);
    }
}
